//+------------------------------------------------------------------+
//|                                                     FiboTime.mq4 |
//|                                                            Talex |
//|                                                 tan@gazinter.net |
//+------------------------------------------------------------------+
#property copyright "Talex"
#property link      "tan@gazinter.net"
#property show_inputs
#import "user32.dll"
int GetClientRect(int hWnd,int lpRect[]);
#import

extern datetime TimePoint1; /*   1   '2008.07.19 12:30' */
extern datetime TimePoint2; /*   2   '2012.07.19 12:30' */
extern bool ShowLine=true; /* true -    */
extern color ExtColor=Red;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimePoint,FiboTime,dt1,dt2;
   int i,j,k,BarPoint,BarPoint1,BarPoint2;
   double MinPrice,MinScale,LinePrice;
   double Fibo[8]={0,0.618, 1.0, 1.272, 1.618, 2.236, 2.618, 3.618};
   string save;
   
   save=TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS);
   for(j=0;j<ObjectsTotal();j++)
   {
    if(ObjectType(ObjectName(j))==OBJ_VLINE)
    {
     dt1=ObjectGet(ObjectName(j),OBJPROP_TIME1);
    }
   }
   for(k=0;k<ObjectsTotal();k++)
   {
    if(ObjectType(ObjectName(k))==OBJ_VLINE)
    {
     if(dt1!=ObjectGet(ObjectName(k),OBJPROP_TIME1))
     dt2=ObjectGet(ObjectName(k),OBJPROP_TIME1);
    }
   }
   if(dt1<dt2){TimePoint1=dt1;TimePoint2=dt2;}else {TimePoint1=dt2;TimePoint2=dt1;}
   if(TimePoint1<TimePoint2)TimePoint=TimePoint1;else TimePoint=TimePoint2;
   
   MinPrice=Low[iLowest(NULL,0,MODE_LOW,iBarShift(NULL,0,TimePoint,false),0)];
   MinScale=WindowPriceMin(0);
   Comment("MinPrice=",MinPrice,"; MinScale=",MinScale);
   LinePrice=NormalizeDouble((4*MinPrice+MinScale)/5,Digits);
   BarPoint1=iBarShift(NULL,0,TimePoint1,false);
   BarPoint2=iBarShift(NULL,0,TimePoint2,false);
   for(i=0;i<8;i++)
   {
    if(BarPoint1*1.0-Fibo[i]*(BarPoint1-BarPoint2)>=0)
    {
     BarPoint=MathRound(BarPoint1*1.0-Fibo[i]*(BarPoint1-BarPoint2));
     FiboTime=iTime(NULL,0,BarPoint);
    }else FiboTime=Time[0]-MathRound(BarPoint1*1.0-Fibo[i]*(BarPoint1-BarPoint2))*Period()*60;
    ObjectCreate("FiboTimeArrow"+i+"_"+save,OBJ_ARROW,0,FiboTime,LinePrice);
    ObjectSet("FiboTimeArrow"+i+"_"+save,OBJPROP_ARROWCODE,233);
    ObjectSet("FiboTimeArrow"+i+"_"+save,OBJPROP_COLOR,ExtColor);
    ObjectCreate("FiboTimeLineText"+i+"_"+save,OBJ_TEXT,0,FiboTime,LinePrice-TextEdit());
    ObjectSetText("FiboTimeLineText"+i+"_"+save,DoubleToStr(Fibo[i],3),8,"Times New Roman",Red);
    ObjectSet("FiboTimeLineText"+i+"_"+save,OBJPROP_COLOR,ExtColor);
    if(ShowLine)
    {
     ObjectCreate("FiboTimeVLine"+i+"_"+save,OBJ_TREND,0,FiboTime,LinePrice,FiboTime,1000);
     ObjectSet("FiboTimeVLine"+i+"_"+save,OBJPROP_COLOR,ExtColor);
    }
   }
   ObjectCreate("FiboTimeLine"+"_"+save,OBJ_TREND,0,TimePoint1,LinePrice,FiboTime,LinePrice);
   ObjectSet("FiboTimeLine"+"_"+save,OBJPROP_RAY,false);
   ObjectSet("FiboTimeLine"+"_"+save,OBJPROP_COLOR,ExtColor);   
   return(0);
  }
//+------------------------------------------------------------------+

/*-----------------------------------------------------+
 
 +-----------------------------------------------------*/
 double TextEdit()
 {
  double MaxPrice,MinPrice,Diapazon,PixelsOfPips,edit;
  int rect[4];
  
  int hwnd=WindowHandle(Symbol(),Period());
  if(hwnd>0) GetClientRect(hwnd,rect);
  int VPixels=rect[3]; //    -   
  
  MaxPrice=WindowPriceMax();//     
  MinPrice=WindowPriceMin();//     
  Diapazon=MaxPrice-MinPrice; //       ,     ,       ,    .
  PixelsOfPips=VPixels/Diapazon; // -   1 
  edit=17/PixelsOfPips; /*  17 -         Arial   -9 */
  Comment("edit: ",edit,"\n","Left: ",rect[0]," Top: ",rect[1]," Right: ",rect[2]," Bottom: ",rect[3],"\n","MaxPrice=",WindowPriceMax(),"; MinPrice=",WindowPriceMin());
  return(edit);
 }
 /*-----------------------------------------*/